{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uServerMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, uServerBaseForm, DDOBase, DDOServer, DDOProgressBar,
  DDODataGrid, ComCtrls, StdCtrls, Spin, Buttons, uAsyncDemo_Stub, ExtCtrls;

type
  TMainForm = class(TServerBaseForm)
    procedure FormCreate(Sender: TObject);
  private
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

type
  TAsyncDemo = class(TAsyncDemo_Stub)
  public
    procedure GetSomeData(ID: Integer; out Data: String); override;
  end;

//----------------------------------------------------------------------------
//2006-02-21 N,SM:

procedure TAsyncDemo.GetSomeData(ID: Integer; out Data: String);
begin
  Data := 'Some Data for ID ' + IntToStr(ID);
  Sleep(Random(5000) + 5000);  // simulate some "lenghty" process
end;

//----------------------------------------------------------------------------
//2006-02-21 N,SM:

procedure TMainForm.FormCreate(Sender: TObject);
begin
  inherited;
  DDOListener1.RegisterClass(TAsyncDemo);
end;

end.
